import webpack from "./webpack";
import * as idb from "idb-keyval";
import * as nests from "nests";
import * as nestsReact from "nests/react";

const { findByProps } = webpack;

const React = findByProps("createElement");

export default {
	React,
	ReactDOM: findByProps("hydrate"),
	dispatch: findByProps("dirtyDispatch").__proto__,
	idb,
	nests
};

export { idb, nests, nestsReact, React };
