import { React, nests, nestsReact } from "../../common";
import { toggle } from "../../plugin";
import webpack from "../../webpack";

const Checkbox = webpack.findByDisplayName("Checkbox");

export default class HummusUI extends React.Component {
	constructor(props) {
		super(props);
		this.state = {
			tg: 0
		};
	}

	render() {
		const extNest = demon.summon("internal/nest");
		return (
			<div className="control-group demon-settings-card-header">
				<label className="demon-settings-header-size30 ">Plugins</label>
				{Object.keys(extNest.ghost.pluginsList).map((k) => {
					return (
						<div className="demon-settings-card-base">
							<span>
								<Checkbox
									className={`demon-stub-plugin-checkbox-${k}`}
									checked={
										extNest.ghost.pluginsStatus[k].running
									}
									onChange={async () => {
										toggle(k);
										const ele =
											document.getElementsByClassName(
												`demon-stub-plugin-checkbox-${k}`
											)[0];
										//ele.value = extNest.ghost.pluginsStatus[k].running
										if (
											!extNest.ghost.pluginsStatus[k]
												.running
										) {
											ele.value = "on";
										} else {
											ele.value = "off";
										}
										this.setState({ tg: !this.state.tg });
									}}
								>
									{k}
								</Checkbox>
							</span>
						</div>
					);
				})}
			</div>
		);
	}
}
