function injectCSS(str) {
	const style = document.createElement("style");
	style.className = "demon-element-css";
	style.innerHTML = str;
	document.head.appendChild(style);
}

function createClass(name, style) {
	const stylestr = Object.entries(style)
		.map(([k, v]) => `${k}:${v}`)
		.join(";");
	injectCSS(`.${name} {${stylestr}}`);
}

export default {
	injectCSS,
	createClass
};
